diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-wp-image-editor-imagick.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-image-editor-imagick.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-wp-image-editor-imagick.php	1969-12-31 17:00:00.000000000 -0700
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-image-editor-imagick.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 0 ****
--- 1,468 ----
+ <?php
+ /**
+  * WordPress Imagick Image Editor
+  *
+  * @package WordPress
+  * @subpackage Image_Editor
+  */
+ 
+ /**
+  * WordPress Image Editor Class for Image Manipulation through Imagick PHP Module
+  *
+  * @since 3.5.0
+  * @package WordPress
+  * @subpackage Image_Editor
+  * @uses WP_Image_Editor Extends class
+  */
+ class WP_Image_Editor_Imagick extends WP_Image_Editor {
+ 
+ 	protected $image = null; // Imagick Object
+ 
+ 	function __destruct() {
+ 		if ( $this->image ) {
+ 			// we don't need the original in memory anymore
+ 			$this->image->clear();
+ 			$this->image->destroy();
+ 		}
+ 	}
+ 
+ 	/**
+ 	 * Checks to see if current environment supports Imagick.
+ 	 *
+ 	 * We require Imagick 2.2.0 or greater, based on whether the queryFormats()
+ 	 * method can be called statically.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @return boolean
+ 	 */
+ 	public static function test( $args = array() ) {
+ 
+ 		// First, test Imagick's extension and classes.
+ 		if ( ! extension_loaded( 'imagick' ) || ! class_exists( 'Imagick' ) || ! class_exists( 'ImagickPixel' ) )
+ 			return false;
+ 
+ 		if ( version_compare( phpversion( 'imagick' ), '2.2.0', '<' ) )
+ 			return false;
+ 
+ 		$required_methods = array(
+ 			'clear',
+ 			'destroy',
+ 			'valid',
+ 			'getimage',
+ 			'writeimage',
+ 			'getimageblob',
+ 			'getimagegeometry',
+ 			'getimageformat',
+ 			'setimageformat',
+ 			'setimagecompression',
+ 			'setimagecompressionquality',
+ 			'setimagepage',
+ 			'scaleimage',
+ 			'cropimage',
+ 			'rotateimage',
+ 			'flipimage',
+ 			'flopimage',
+ 		);
+ 
+ 		// Now, test for deep requirements within Imagick.
+ 		if ( ! defined( 'imagick::COMPRESSION_JPEG' ) )
+ 			return false;
+ 
+ 		if ( array_diff( $required_methods, get_class_methods( 'Imagick' ) ) )
+ 			return false;
+ 
+ 		return true;
+ 	}
+ 
+ 	/**
+ 	 * Checks to see if editor supports the mime-type specified.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param string $mime_type
+ 	 * @return boolean
+ 	 */
+ 	public static function supports_mime_type( $mime_type ) {
+ 		$imagick_extension = strtoupper( self::get_extension( $mime_type ) );
+ 
+ 		if ( ! $imagick_extension )
+ 			return false;
+ 
+ 		// setIteratorIndex is optional unless mime is an animated format.
+ 		// Here, we just say no if you are missing it and aren't loading a jpeg.
+ 		if ( ! method_exists( 'Imagick', 'setIteratorIndex' ) && $mime_type != 'image/jpeg' )
+ 				return false;
+ 
+ 		try {
+ 			return ( (bool) Imagick::queryFormats( $imagick_extension ) );
+ 		}
+ 		catch ( Exception $e ) {
+ 			return false;
+ 		}
+ 	}
+ 
+ 	/**
+ 	 * Loads image from $this->file into new Imagick Object.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access protected
+ 	 *
+ 	 * @return boolean|WP_Error True if loaded; WP_Error on failure.
+ 	 */
+ 	public function load() {
+ 		if ( $this->image )
+ 			return true;
+ 
+ 		if ( ! is_file( $this->file ) && ! preg_match( '|^https?://|', $this->file ) )
+ 			return new WP_Error( 'error_loading_image', __('File doesn&#8217;t exist?'), $this->file );
+ 
+ 		// Even though Imagick uses less PHP memory than GD, set higher limit for users that have low PHP.ini limits
+ 		@ini_set( 'memory_limit', apply_filters( 'image_memory_limit', WP_MAX_MEMORY_LIMIT ) );
+ 
+ 		try {
+ 			$this->image = new Imagick( $this->file );
+ 
+ 			if( ! $this->image->valid() )
+ 				return new WP_Error( 'invalid_image', __('File is not an image.'), $this->file);
+ 
+ 			// Select the first frame to handle animated images properly
+ 			if ( is_callable( array( $this->image, 'setIteratorIndex' ) ) )
+ 				$this->image->setIteratorIndex(0);
+ 
+ 			$this->mime_type = $this->get_mime_type( $this->image->getImageFormat() );
+ 		}
+ 		catch ( Exception $e ) {
+ 			return new WP_Error( 'invalid_image', $e->getMessage(), $this->file );
+ 		}
+ 
+ 		$updated_size = $this->update_size();
+ 		if ( is_wp_error( $updated_size ) )
+ 				return $updated_size;
+ 
+ 		return $this->set_quality();
+ 	}
+ 
+ 	/**
+ 	 * Sets Image Compression quality on a 1-100% scale.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param int $quality Compression Quality. Range: [1,100]
+ 	 * @return boolean|WP_Error
+ 	 */
+ 	public function set_quality( $quality = null ) {
+ 		if ( !$quality )
+ 			$quality = $this->quality;
+ 
+ 		try {
+ 			if( 'image/jpeg' == $this->mime_type ) {
+ 				$this->image->setImageCompressionQuality( apply_filters( 'jpeg_quality', $quality, 'image_resize' ) );
+ 				$this->image->setImageCompression( imagick::COMPRESSION_JPEG );
+ 			}
+ 			else {
+ 				$this->image->setImageCompressionQuality( $quality );
+ 			}
+ 		}
+ 		catch ( Exception $e ) {
+ 			return new WP_Error( 'image_quality_error', $e->getMessage() );
+ 		}
+ 
+ 		return parent::set_quality( $quality );
+ 	}
+ 
+ 	/**
+ 	 * Sets or updates current image size.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access protected
+ 	 *
+ 	 * @param int $width
+ 	 * @param int $height
+ 	 */
+ 	protected function update_size( $width = null, $height = null ) {
+ 		$size = null;
+ 		if ( !$width || !$height ) {
+ 			try {
+ 				$size = $this->image->getImageGeometry();
+ 			}
+ 			catch ( Exception $e ) {
+ 				return new WP_Error( 'invalid_image', __('Could not read image size'), $this->file );
+ 			}
+ 		}
+ 
+ 		if ( ! $width )
+ 			$width = $size['width'];
+ 
+ 		if ( ! $height )
+ 			$height = $size['height'];
+ 
+ 		return parent::update_size( $width, $height );
+ 	}
+ 
+ 	/**
+ 	 * Resizes current image.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param int $max_w
+ 	 * @param int $max_h
+ 	 * @param boolean $crop
+ 	 * @return boolean|WP_Error
+ 	 */
+ 	public function resize( $max_w, $max_h, $crop = false ) {
+ 		if ( ( $this->size['width'] == $max_w ) && ( $this->size['height'] == $max_h ) )
+ 			return true;
+ 
+ 		$dims = image_resize_dimensions( $this->size['width'], $this->size['height'], $max_w, $max_h, $crop );
+ 		if ( ! $dims )
+ 			return new WP_Error( 'error_getting_dimensions', __('Could not calculate resized image dimensions') );
+ 		list( $dst_x, $dst_y, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h ) = $dims;
+ 
+ 		if ( $crop ) {
+ 			return $this->crop( $src_x, $src_y, $src_w, $src_h, $dst_w, $dst_h );
+ 		}
+ 
+ 		try {
+ 			/**
+ 			 * @TODO: Thumbnail is more efficient, given a newer version of Imagemagick.
+ 			 * $this->image->thumbnailImage( $dst_w, $dst_h );
+ 			 */
+ 			$this->image->scaleImage( $dst_w, $dst_h );
+ 		}
+ 		catch ( Exception $e ) {
+ 			return new WP_Error( 'image_resize_error', $e->getMessage() );
+ 		}
+ 
+ 		return $this->update_size( $dst_w, $dst_h );
+ 	}
+ 
+ 	/**
+ 	 * Processes current image and saves to disk
+ 	 * multiple sizes from single source.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param array $sizes { {'width'=>int, 'height'=>int, 'crop'=>bool}, ... }
+ 	 * @return array
+ 	 */
+ 	public function multi_resize( $sizes ) {
+ 		$metadata = array();
+ 		$orig_size = $this->size;
+ 		$orig_image = $this->image->getImage();
+ 
+ 		foreach ( $sizes as $size => $size_data ) {
+ 			if ( ! $this->image )
+ 				$this->image = $orig_image->getImage();
+ 
+ 			$resize_result = $this->resize( $size_data['width'], $size_data['height'], $size_data['crop'] );
+ 
+ 			if( ! is_wp_error( $resize_result ) ) {
+ 				$resized = $this->_save( $this->image );
+ 
+ 				$this->image->clear();
+ 				$this->image->destroy();
+ 				$this->image = null;
+ 
+ 				if ( ! is_wp_error( $resized ) && $resized ) {
+ 					unset( $resized['path'] );
+ 					$metadata[$size] = $resized;
+ 				}
+ 			}
+ 
+ 			$this->size = $orig_size;
+ 		}
+ 
+ 		$this->image = $orig_image;
+ 
+ 		return $metadata;
+ 	}
+ 
+ 	/**
+ 	 * Crops Image.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param string|int $src The source file or Attachment ID.
+ 	 * @param int $src_x The start x position to crop from.
+ 	 * @param int $src_y The start y position to crop from.
+ 	 * @param int $src_w The width to crop.
+ 	 * @param int $src_h The height to crop.
+ 	 * @param int $dst_w Optional. The destination width.
+ 	 * @param int $dst_h Optional. The destination height.
+ 	 * @param boolean $src_abs Optional. If the source crop points are absolute.
+ 	 * @return boolean|WP_Error
+ 	 */
+ 	public function crop( $src_x, $src_y, $src_w, $src_h, $dst_w = null, $dst_h = null, $src_abs = false ) {
+ 		if ( $src_abs ) {
+ 			$src_w -= $src_x;
+ 			$src_h -= $src_y;
+ 		}
+ 
+ 		try {
+ 			$this->image->cropImage( $src_w, $src_h, $src_x, $src_y );
+ 			$this->image->setImagePage( $src_w, $src_h, 0, 0);
+ 
+ 			if ( $dst_w || $dst_h ) {
+ 				// If destination width/height isn't specified, use same as
+ 				// width/height from source.
+ 				if ( ! $dst_w )
+ 					$dst_w = $src_w;
+ 				if ( ! $dst_h )
+ 					$dst_h = $src_h;
+ 
+ 				$this->image->scaleImage( $dst_w, $dst_h );
+ 				return $this->update_size();
+ 			}
+ 		}
+ 		catch ( Exception $e ) {
+ 			return new WP_Error( 'image_crop_error', $e->getMessage() );
+ 		}
+ 		return $this->update_size();
+ 	}
+ 
+ 	/**
+ 	 * Rotates current image counter-clockwise by $angle.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param float $angle
+ 	 * @return boolean|WP_Error
+ 	 */
+ 	public function rotate( $angle ) {
+ 		/**
+ 		 * $angle is 360-$angle because Imagick rotates clockwise
+ 		 * (GD rotates counter-clockwise)
+ 		 */
+ 		try {
+ 			$this->image->rotateImage( new ImagickPixel('none'), 360-$angle );
+ 		}
+ 		catch ( Exception $e ) {
+ 			return new WP_Error( 'image_rotate_error', $e->getMessage() );
+ 		}
+ 		return $this->update_size();
+ 	}
+ 
+ 	/**
+ 	 * Flips current image.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param boolean $horz Horizontal Flip
+ 	 * @param boolean $vert Vertical Flip
+ 	 * @returns boolean|WP_Error
+ 	 */
+ 	public function flip( $horz, $vert ) {
+ 		try {
+ 			if ( $horz )
+ 				$this->image->flipImage();
+ 
+ 			if ( $vert )
+ 				$this->image->flopImage();
+ 		}
+ 		catch ( Exception $e ) {
+ 			return new WP_Error( 'image_flip_error', $e->getMessage() );
+ 		}
+ 		return true;
+ 	}
+ 
+ 	/**
+ 	 * Saves current image to file.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param string $destfilename
+ 	 * @param string $mime_type
+ 	 * @return array|WP_Error {'path'=>string, 'file'=>string, 'width'=>int, 'height'=>int, 'mime-type'=>string}
+ 	 */
+ 	public function save( $destfilename = null, $mime_type = null ) {
+ 		$saved = $this->_save( $this->image, $destfilename, $mime_type );
+ 
+ 		if ( ! is_wp_error( $saved ) ) {
+ 			$this->file = $saved['path'];
+ 			$this->mime_type = $saved['mime-type'];
+ 
+ 			try {
+ 				$this->image->setImageFormat( strtoupper( $this->get_extension( $this->mime_type ) ) );
+ 			}
+ 			catch ( Exception $e ) {
+ 				return new WP_Error( 'image_save_error', $e->getMessage(), $this->file );
+ 			}
+ 		}
+ 
+ 		return $saved;
+ 	}
+ 
+ 	protected function _save( $image, $filename = null, $mime_type = null ) {
+ 		list( $filename, $extension, $mime_type ) = $this->get_output_format( $filename, $mime_type );
+ 
+ 		if ( ! $filename )
+ 			$filename = $this->generate_filename( null, null, $extension );
+ 
+ 		try {
+ 			// Store initial Format
+ 			$orig_format = $this->image->getImageFormat();
+ 
+ 			$this->image->setImageFormat( strtoupper( $this->get_extension( $mime_type ) ) );
+ 			$this->make_image( $filename, array( $image, 'writeImage' ), array( $filename ) );
+ 
+ 			// Reset original Format
+ 			$this->image->setImageFormat( $orig_format );
+ 		}
+ 		catch ( Exception $e ) {
+ 			return new WP_Error( 'image_save_error', $e->getMessage(), $filename );
+ 		}
+ 
+ 		// Set correct file permissions
+ 		$stat = stat( dirname( $filename ) );
+ 		$perms = $stat['mode'] & 0000666; //same permissions as parent folder, strip off the executable bits
+ 		@ chmod( $filename, $perms );
+ 
+ 		return array(
+ 			'path' => $filename,
+ 			'file' => wp_basename( apply_filters( 'image_make_intermediate_size', $filename ) ),
+ 			'width' => $this->size['width'],
+ 			'height' => $this->size['height'],
+ 			'mime-type' => $mime_type,
+ 		);
+ 	}
+ 
+ 	/**
+ 	 * Streams current image to browser.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param string $mime_type
+ 	 * @return boolean|WP_Error
+ 	 */
+ 	public function stream( $mime_type = null ) {
+ 		list( $filename, $extension, $mime_type ) = $this->get_output_format( null, $mime_type );
+ 
+ 		try {
+ 			// Temporarily change format for stream
+ 			$this->image->setImageFormat( strtoupper( $extension ) );
+ 
+ 			// Output stream of image content
+ 			header( "Content-Type: $mime_type" );
+ 			print $this->image->getImageBlob();
+ 
+ 			// Reset Image to original Format
+ 			$this->image->setImageFormat( $this->get_extension( $this->mime_type ) );
+ 		}
+ 		catch ( Exception $e ) {
+ 			return new WP_Error( 'image_stream_error', $e->getMessage() );
+ 		}
+ 
+ 		return true;
+ 	}
+ }
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-wp-image-editor.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-image-editor.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-wp-image-editor.php	1969-12-31 17:00:00.000000000 -0700
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-image-editor.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 0 ****
--- 1,400 ----
+ <?php
+ /**
+  * Base WordPress Image Editor
+  *
+  * @package WordPress
+  * @subpackage Image_Editor
+  */
+ 
+ /**
+  * Base image editor class from which implementations extend
+  *
+  * @since 3.5.0
+  */
+ abstract class WP_Image_Editor {
+ 	protected $file = null;
+ 	protected $size = null;
+ 	protected $mime_type = null;
+ 	protected $default_mime_type = 'image/jpeg';
+ 	protected $quality = 90;
+ 
+ 	/**
+ 	 * Each instance handles a single file.
+ 	 */
+ 	public function __construct( $file ) {
+ 		$this->file = $file;
+ 	}
+ 
+ 	/**
+ 	 * Checks to see if current environment supports the editor chosen.
+ 	 * Must be overridden in a sub-class.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 * @abstract
+ 	 *
+ 	 * @param array $args
+ 	 * @return boolean
+ 	 */
+ 	public static function test( $args = array() ) {
+ 		return false;
+ 	}
+ 
+ 	/**
+ 	 * Checks to see if editor supports the mime-type specified.
+ 	 * Must be overridden in a sub-class.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 * @abstract
+ 	 *
+ 	 * @param string $mime_type
+ 	 * @return boolean
+ 	 */
+ 	public static function supports_mime_type( $mime_type ) {
+ 		return false;
+ 	}
+ 
+ 	/**
+ 	 * Loads image from $this->file into editor.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access protected
+ 	 * @abstract
+ 	 *
+ 	 * @return boolean|WP_Error True if loaded; WP_Error on failure.
+ 	 */
+ 	abstract public function load();
+ 
+ 	/**
+ 	 * Saves current image to file.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 * @abstract
+ 	 *
+ 	 * @param string $destfilename
+ 	 * @param string $mime_type
+ 	 * @return array|WP_Error {'path'=>string, 'file'=>string, 'width'=>int, 'height'=>int, 'mime-type'=>string}
+ 	 */
+ 	abstract public function save( $destfilename = null, $mime_type = null );
+ 
+ 	/**
+ 	 * Resizes current image.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 * @abstract
+ 	 *
+ 	 * @param int $max_w
+ 	 * @param int $max_h
+ 	 * @param boolean $crop
+ 	 * @return boolean|WP_Error
+ 	 */
+ 	abstract public function resize( $max_w, $max_h, $crop = false );
+ 
+ 	/**
+ 	 * Processes current image and saves to disk
+ 	 * multiple sizes from single source.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 * @abstract
+ 	 *
+ 	 * @param array $sizes { {'width'=>int, 'height'=>int, 'crop'=>bool}, ... }
+ 	 * @return array
+ 	 */
+ 	abstract public function multi_resize( $sizes );
+ 
+ 	/**
+ 	 * Crops Image.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 * @abstract
+ 	 *
+ 	 * @param string|int $src The source file or Attachment ID.
+ 	 * @param int $src_x The start x position to crop from.
+ 	 * @param int $src_y The start y position to crop from.
+ 	 * @param int $src_w The width to crop.
+ 	 * @param int $src_h The height to crop.
+ 	 * @param int $dst_w Optional. The destination width.
+ 	 * @param int $dst_h Optional. The destination height.
+ 	 * @param boolean $src_abs Optional. If the source crop points are absolute.
+ 	 * @return boolean|WP_Error
+ 	 */
+ 	abstract public function crop( $src_x, $src_y, $src_w, $src_h, $dst_w = null, $dst_h = null, $src_abs = false );
+ 
+ 	/**
+ 	 * Rotates current image counter-clockwise by $angle.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 * @abstract
+ 	 *
+ 	 * @param float $angle
+ 	 * @return boolean|WP_Error
+ 	 */
+ 	abstract public function rotate( $angle );
+ 
+ 	/**
+ 	 * Flips current image.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 * @abstract
+ 	 *
+ 	 * @param boolean $horz Horizontal Flip
+ 	 * @param boolean $vert Vertical Flip
+ 	 * @return boolean|WP_Error
+ 	 */
+ 	abstract public function flip( $horz, $vert );
+ 
+ 	/**
+ 	 * Streams current image to browser.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 * @abstract
+ 	 *
+ 	 * @param string $mime_type
+ 	 * @return boolean|WP_Error
+ 	 */
+ 	abstract public function stream( $mime_type = null );
+ 
+ 	/**
+ 	 * Gets dimensions of image.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @return array {'width'=>int, 'height'=>int}
+ 	 */
+ 	public function get_size() {
+ 		return $this->size;
+ 	}
+ 
+ 	/**
+ 	 * Sets current image size.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access protected
+ 	 *
+ 	 * @param int $width
+ 	 * @param int $height
+ 	 */
+ 	protected function update_size( $width = null, $height = null ) {
+ 		$this->size = array(
+ 			'width' => (int) $width,
+ 			'height' => (int) $height
+ 		);
+ 		return true;
+ 	}
+ 
+ 	/**
+ 	 * Sets Image Compression quality on a 1-100% scale.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param int $quality Compression Quality. Range: [1,100]
+ 	 * @return boolean
+ 	 */
+ 	public function set_quality( $quality ) {
+ 		$this->quality = apply_filters( 'wp_editor_set_quality', $quality );
+ 
+ 		return ( (bool) $this->quality );
+ 	}
+ 
+ 	/**
+ 	 * Returns preferred mime-type and extension based on provided
+ 	 * file's extension and mime, or current file's extension and mime.
+ 	 *
+ 	 * Will default to $this->default_mime_type if requested is not supported.
+ 	 *
+ 	 * Provides corrected filename only if filename is provided.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access protected
+ 	 *
+ 	 * @param string $filename
+ 	 * @param string $mime_type
+ 	 * @return array { filename|null, extension, mime-type }
+ 	 */
+ 	protected function get_output_format( $filename = null, $mime_type = null ) {
+ 		$new_ext = $file_ext = null;
+ 		$file_mime = null;
+ 
+ 		// By default, assume specified type takes priority
+ 		if ( $mime_type ) {
+ 			$new_ext = $this->get_extension( $mime_type );
+ 		}
+ 
+ 		if ( $filename ) {
+ 			$file_ext = strtolower( pathinfo( $filename, PATHINFO_EXTENSION ) );
+ 			$file_mime = $this->get_mime_type( $file_ext );
+ 		}
+ 		else {
+ 			// If no file specified, grab editor's current extension and mime-type.
+ 			$file_ext = strtolower( pathinfo( $this->file, PATHINFO_EXTENSION ) );
+ 			$file_mime = $this->mime_type;
+ 		}
+ 
+ 		// Check to see if specified mime-type is the same as type implied by
+ 		// file extension.  If so, prefer extension from file.
+ 		if ( ! $mime_type || ( $file_mime == $mime_type ) ) {
+ 			$mime_type = $file_mime;
+ 			$new_ext = $file_ext;
+ 		}
+ 
+ 		// Double-check that the mime-type selected is supported by the editor.
+ 		// If not, choose a default instead.
+ 		if ( ! $this->supports_mime_type( $mime_type ) ) {
+ 			$mime_type = apply_filters( 'image_editor_default_mime_type', $this->default_mime_type );
+ 			$new_ext = $this->get_extension( $mime_type );
+ 		}
+ 
+ 		if ( $filename ) {
+ 			$ext = '';
+ 			$info = pathinfo( $filename );
+ 			$dir  = $info['dirname'];
+ 
+ 			if( isset( $info['extension'] ) )
+ 				$ext = $info['extension'];
+ 
+ 			$filename = trailingslashit( $dir ) . wp_basename( $filename, ".$ext" ) . ".{$new_ext}";
+ 		}
+ 
+ 		return array( $filename, $new_ext, $mime_type );
+ 	}
+ 
+ 	/**
+ 	 * Builds an output filename based on current file, and adding proper suffix
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param string $suffix
+ 	 * @param string $dest_path
+ 	 * @param string $extension
+ 	 * @return string filename
+ 	 */
+ 	public function generate_filename( $suffix = null, $dest_path = null, $extension = null ) {
+ 		// $suffix will be appended to the destination filename, just before the extension
+ 		if ( ! $suffix )
+ 			$suffix = $this->get_suffix();
+ 
+ 		$info = pathinfo( $this->file );
+ 		$dir  = $info['dirname'];
+ 		$ext  = $info['extension'];
+ 
+ 		$name = wp_basename( $this->file, ".$ext" );
+ 		$new_ext = strtolower( $extension ? $extension : $ext );
+ 
+ 		if ( ! is_null( $dest_path ) && $_dest_path = realpath( $dest_path ) )
+ 			$dir = $_dest_path;
+ 
+ 		return trailingslashit( $dir ) . "{$name}-{$suffix}.{$new_ext}";
+ 	}
+ 
+ 	/**
+ 	 * Builds and returns proper suffix for file based on height and width.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @return string suffix
+ 	 */
+ 	public function get_suffix() {
+ 		if ( ! $this->get_size() )
+ 			return false;
+ 
+ 		return "{$this->size['width']}x{$this->size['height']}";
+ 	}
+ 
+ 	/**
+ 	 * Either calls editor's save function or handles file as a stream.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access protected
+ 	 *
+ 	 * @param string|stream $filename
+ 	 * @param callable $function
+ 	 * @param array $arguments
+ 	 * @return boolean
+ 	 */
+ 	protected function make_image( $filename, $function, $arguments ) {
+ 		$dst_file = $filename;
+ 
+ 		if ( $stream = wp_is_stream( $filename ) ) {
+ 			$filename = null;
+ 			ob_start();
+ 		}
+ 
+ 		$result = call_user_func_array( $function, $arguments );
+ 
+ 		if ( $result && $stream ) {
+ 			$contents = ob_get_contents();
+ 
+ 			$fp = fopen( $dst_file, 'w' );
+ 
+ 			if ( ! $fp )
+ 				return false;
+ 
+ 			fwrite( $fp, $contents );
+ 			fclose( $fp );
+ 		}
+ 
+ 		if ( $stream ) {
+ 			ob_end_clean();
+ 		}
+ 
+ 		return $result;
+ 	}
+ 
+ 	/**
+ 	 * Returns first matched mime-type from extension,
+ 	 * as mapped from wp_get_mime_types()
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access protected
+ 	 *
+ 	 * @param string $extension
+ 	 * @return string|boolean
+ 	 */
+ 	protected static function get_mime_type( $extension = null ) {
+ 		if ( ! $extension )
+ 			return false;
+ 
+ 		$mime_types = wp_get_mime_types();
+ 		$extensions = array_keys( $mime_types );
+ 
+ 		foreach( $extensions as $_extension ) {
+ 			if ( preg_match( "/{$extension}/i", $_extension ) ) {
+ 				return $mime_types[$_extension];
+ 			}
+ 		}
+ 
+ 		return false;
+ 	}
+ 
+ 	/**
+ 	 * Returns first matched extension from Mime-type,
+ 	 * as mapped from wp_get_mime_types()
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access protected
+ 	 *
+ 	 * @param string $mime_type
+ 	 * @return string|boolean
+ 	 */
+ 	protected static function get_extension( $mime_type = null ) {
+ 		$extensions = explode( '|', array_search( $mime_type, wp_get_mime_types() ) );
+ 
+ 		if ( empty( $extensions[0] ) )
+ 			return false;
+ 
+ 		return $extensions[0];
+ 	}
+ }
+ 
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-wp.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-wp.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp.php	2012-12-17 16:18:40.000000000 -0600
***************
*** 120,125 ****
--- 120,128 ----
  	function parse_request($extra_query_vars = '') {
  		global $wp_rewrite;
  
+ 		if ( ! apply_filters( 'do_parse_request', true, $this, $extra_query_vars ) )
+ 			return;
+ 
  		$this->query_vars = array();
  		$post_type_query_vars = array();
  
***************
*** 161,173 ****
  			// requested permalink.
  			$req_uri = str_replace($pathinfo, '', $req_uri);
  			$req_uri = trim($req_uri, '/');
! 			$req_uri = preg_replace("|^$home_path|", '', $req_uri);
  			$req_uri = trim($req_uri, '/');
  			$pathinfo = trim($pathinfo, '/');
! 			$pathinfo = preg_replace("|^$home_path|", '', $pathinfo);
  			$pathinfo = trim($pathinfo, '/');
  			$self = trim($self, '/');
! 			$self = preg_replace("|^$home_path|", '', $self);
  			$self = trim($self, '/');
  
  			// The requested permalink is in $pathinfo for path info requests and
--- 164,176 ----
  			// requested permalink.
  			$req_uri = str_replace($pathinfo, '', $req_uri);
  			$req_uri = trim($req_uri, '/');
! 			$req_uri = preg_replace("|^$home_path|i", '', $req_uri);
  			$req_uri = trim($req_uri, '/');
  			$pathinfo = trim($pathinfo, '/');
! 			$pathinfo = preg_replace("|^$home_path|i", '', $pathinfo);
  			$pathinfo = trim($pathinfo, '/');
  			$self = trim($self, '/');
! 			$self = preg_replace("|^$home_path|i", '', $self);
  			$self = trim($self, '/');
  
  			// The requested permalink is in $pathinfo for path info requests and
***************
*** 192,198 ****
  					$query = $rewrite['$'];
  					$matches = array('');
  				}
! 			} else if ( $req_uri != 'wp-app.php' ) {
  				foreach ( (array) $rewrite as $match => $query ) {
  					// If the requesting file is the anchor of the match, prepend it to the path info.
  					if ( ! empty($req_uri) && strpos($match, $req_uri) === 0 && $req_uri != $request )
--- 195,201 ----
  					$query = $rewrite['$'];
  					$matches = array('');
  				}
! 			} else {
  				foreach ( (array) $rewrite as $match => $query ) {
  					// If the requesting file is the anchor of the match, prepend it to the path info.
  					if ( ! empty($req_uri) && strpos($match, $req_uri) === 0 && $req_uri != $request )
***************
*** 226,241 ****
  				// Parse the query.
  				parse_str($query, $perma_query_vars);
  
! 				// If we're processing a 404 request, clear the error var
! 				// since we found something.
! 				unset( $_GET['error'] );
! 				unset( $error );
  			}
  
  			// If req_uri is empty or if it is a request for ourself, unset error.
  			if ( empty($request) || $req_uri == $self || strpos($_SERVER['PHP_SELF'], 'wp-admin/') !== false ) {
! 				unset( $_GET['error'] );
! 				unset( $error );
  
  				if ( isset($perma_query_vars) && strpos($_SERVER['PHP_SELF'], 'wp-admin/') !== false )
  					unset( $perma_query_vars );
--- 229,242 ----
  				// Parse the query.
  				parse_str($query, $perma_query_vars);
  
! 				// If we're processing a 404 request, clear the error var since we found something.
! 				if ( '404' == $error )
! 					unset( $error, $_GET['error'] );
  			}
  
  			// If req_uri is empty or if it is a request for ourself, unset error.
  			if ( empty($request) || $req_uri == $self || strpos($_SERVER['PHP_SELF'], 'wp-admin/') !== false ) {
! 				unset( $error, $_GET['error'] );
  
  				if ( isset($perma_query_vars) && strpos($_SERVER['PHP_SELF'], 'wp-admin/') !== false )
  					unset( $perma_query_vars );
***************
*** 322,332 ****
  
  		if ( is_user_logged_in() )
  			$headers = array_merge($headers, wp_get_nocache_headers());
! 		if ( !empty($this->query_vars['error']) && '404' == $this->query_vars['error'] ) {
! 			$status = 404;
! 			if ( !is_user_logged_in() )
! 				$headers = array_merge($headers, wp_get_nocache_headers());
! 			$headers['Content-Type'] = get_option('html_type') . '; charset=' . get_option('blog_charset');
  		} else if ( empty($this->query_vars['feed']) ) {
  			$headers['Content-Type'] = get_option('html_type') . '; charset=' . get_option('blog_charset');
  		} else {
--- 323,337 ----
  
  		if ( is_user_logged_in() )
  			$headers = array_merge($headers, wp_get_nocache_headers());
! 		if ( ! empty( $this->query_vars['error'] ) ) {
! 			$status = (int) $this->query_vars['error'];
! 			if ( 404 === $status ) {
! 				if ( ! is_user_logged_in() )
! 					$headers = array_merge($headers, wp_get_nocache_headers());
! 				$headers['Content-Type'] = get_option('html_type') . '; charset=' . get_option('blog_charset');
! 			} elseif ( in_array( $status, array( 403, 500, 502, 503 ) ) ) {
! 				$exit_required = true;
! 			}
  		} else if ( empty($this->query_vars['feed']) ) {
  			$headers['Content-Type'] = get_option('html_type') . '; charset=' . get_option('blog_charset');
  		} else {
***************
*** 376,381 ****
--- 381,389 ----
  		foreach( (array) $headers as $name => $field_value )
  			@header("{$name}: {$field_value}");
  
+ 		if ( isset( $headers['Last-Modified'] ) && empty( $headers['Last-Modified'] ) && function_exists( 'header_remove' ) )
+ 			@header_remove( 'Last-Modified' );
+ 
  		if ( $exit_required )
  			exit();
  
***************
*** 601,607 ****
  	 * @return string
  	 */
  	function _map() {
! 		$callback = array(&$this, 'callback');
  		return preg_replace_callback($this->_pattern, $callback, $this->_subject);
  	}
  
--- 609,615 ----
  	 * @return string
  	 */
  	function _map() {
! 		$callback = array($this, 'callback');
  		return preg_replace_callback($this->_pattern, $callback, $this->_subject);
  	}
  
